/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type {
  FunctionFragment,
  Result,
  EventFragment,
} from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../common";

export declare namespace IRouter {
  export type PluginStruct = {
    functionSelector: PromiseOrValue<BytesLike>;
    functionSignature: PromiseOrValue<string>;
    pluginAddress: PromiseOrValue<string>;
  };

  export type PluginStructOutput = [string, string, string] & {
    functionSelector: string;
    functionSignature: string;
    pluginAddress: string;
  };
}

export interface IRouterInterface extends utils.Interface {
  functions: {
    "addPlugin((bytes4,string,address))": FunctionFragment;
    "getAllFunctionsOfPlugin(address)": FunctionFragment;
    "getAllPlugins()": FunctionFragment;
    "getPluginForFunction(bytes4)": FunctionFragment;
    "removePlugin(bytes4,string)": FunctionFragment;
    "updatePlugin((bytes4,string,address))": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic:
      | "addPlugin"
      | "getAllFunctionsOfPlugin"
      | "getAllPlugins"
      | "getPluginForFunction"
      | "removePlugin"
      | "updatePlugin"
  ): FunctionFragment;

  encodeFunctionData(
    functionFragment: "addPlugin",
    values: [IRouter.PluginStruct]
  ): string;
  encodeFunctionData(
    functionFragment: "getAllFunctionsOfPlugin",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "getAllPlugins",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getPluginForFunction",
    values: [PromiseOrValue<BytesLike>]
  ): string;
  encodeFunctionData(
    functionFragment: "removePlugin",
    values: [PromiseOrValue<BytesLike>, PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "updatePlugin",
    values: [IRouter.PluginStruct]
  ): string;

  decodeFunctionResult(functionFragment: "addPlugin", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "getAllFunctionsOfPlugin",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getAllPlugins",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getPluginForFunction",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "removePlugin",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "updatePlugin",
    data: BytesLike
  ): Result;

  events: {
    "PluginAdded(bytes4,address)": EventFragment;
    "PluginRemoved(bytes4,address)": EventFragment;
    "PluginSet(bytes4,string,address)": EventFragment;
    "PluginUpdated(bytes4,address,address)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "PluginAdded"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "PluginRemoved"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "PluginSet"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "PluginUpdated"): EventFragment;
}

export interface PluginAddedEventObject {
  functionSelector: string;
  pluginAddress: string;
}
export type PluginAddedEvent = TypedEvent<
  [string, string],
  PluginAddedEventObject
>;

export type PluginAddedEventFilter = TypedEventFilter<PluginAddedEvent>;

export interface PluginRemovedEventObject {
  functionSelector: string;
  pluginAddress: string;
}
export type PluginRemovedEvent = TypedEvent<
  [string, string],
  PluginRemovedEventObject
>;

export type PluginRemovedEventFilter = TypedEventFilter<PluginRemovedEvent>;

export interface PluginSetEventObject {
  functionSelector: string;
  functionSignature: string;
  pluginAddress: string;
}
export type PluginSetEvent = TypedEvent<
  [string, string, string],
  PluginSetEventObject
>;

export type PluginSetEventFilter = TypedEventFilter<PluginSetEvent>;

export interface PluginUpdatedEventObject {
  functionSelector: string;
  oldPluginAddress: string;
  newPluginAddress: string;
}
export type PluginUpdatedEvent = TypedEvent<
  [string, string, string],
  PluginUpdatedEventObject
>;

export type PluginUpdatedEventFilter = TypedEventFilter<PluginUpdatedEvent>;

export interface IRouter extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: IRouterInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    addPlugin(
      plugin: IRouter.PluginStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    getAllFunctionsOfPlugin(
      pluginAddress: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[string[]]>;

    getAllPlugins(
      overrides?: CallOverrides
    ): Promise<[IRouter.PluginStructOutput[]]>;

    getPluginForFunction(
      functionSelector: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<[string]>;

    removePlugin(
      selector: PromiseOrValue<BytesLike>,
      functionSignature: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    updatePlugin(
      plugin: IRouter.PluginStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;
  };

  addPlugin(
    plugin: IRouter.PluginStruct,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  getAllFunctionsOfPlugin(
    pluginAddress: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<string[]>;

  getAllPlugins(
    overrides?: CallOverrides
  ): Promise<IRouter.PluginStructOutput[]>;

  getPluginForFunction(
    functionSelector: PromiseOrValue<BytesLike>,
    overrides?: CallOverrides
  ): Promise<string>;

  removePlugin(
    selector: PromiseOrValue<BytesLike>,
    functionSignature: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  updatePlugin(
    plugin: IRouter.PluginStruct,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  callStatic: {
    addPlugin(
      plugin: IRouter.PluginStruct,
      overrides?: CallOverrides
    ): Promise<void>;

    getAllFunctionsOfPlugin(
      pluginAddress: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<string[]>;

    getAllPlugins(
      overrides?: CallOverrides
    ): Promise<IRouter.PluginStructOutput[]>;

    getPluginForFunction(
      functionSelector: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<string>;

    removePlugin(
      selector: PromiseOrValue<BytesLike>,
      functionSignature: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    updatePlugin(
      plugin: IRouter.PluginStruct,
      overrides?: CallOverrides
    ): Promise<void>;
  };

  filters: {
    "PluginAdded(bytes4,address)"(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      pluginAddress?: PromiseOrValue<string> | null
    ): PluginAddedEventFilter;
    PluginAdded(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      pluginAddress?: PromiseOrValue<string> | null
    ): PluginAddedEventFilter;

    "PluginRemoved(bytes4,address)"(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      pluginAddress?: PromiseOrValue<string> | null
    ): PluginRemovedEventFilter;
    PluginRemoved(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      pluginAddress?: PromiseOrValue<string> | null
    ): PluginRemovedEventFilter;

    "PluginSet(bytes4,string,address)"(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      functionSignature?: PromiseOrValue<string> | null,
      pluginAddress?: PromiseOrValue<string> | null
    ): PluginSetEventFilter;
    PluginSet(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      functionSignature?: PromiseOrValue<string> | null,
      pluginAddress?: PromiseOrValue<string> | null
    ): PluginSetEventFilter;

    "PluginUpdated(bytes4,address,address)"(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      oldPluginAddress?: PromiseOrValue<string> | null,
      newPluginAddress?: PromiseOrValue<string> | null
    ): PluginUpdatedEventFilter;
    PluginUpdated(
      functionSelector?: PromiseOrValue<BytesLike> | null,
      oldPluginAddress?: PromiseOrValue<string> | null,
      newPluginAddress?: PromiseOrValue<string> | null
    ): PluginUpdatedEventFilter;
  };

  estimateGas: {
    addPlugin(
      plugin: IRouter.PluginStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    getAllFunctionsOfPlugin(
      pluginAddress: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getAllPlugins(overrides?: CallOverrides): Promise<BigNumber>;

    getPluginForFunction(
      functionSelector: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    removePlugin(
      selector: PromiseOrValue<BytesLike>,
      functionSignature: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    updatePlugin(
      plugin: IRouter.PluginStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    addPlugin(
      plugin: IRouter.PluginStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    getAllFunctionsOfPlugin(
      pluginAddress: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getAllPlugins(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    getPluginForFunction(
      functionSelector: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    removePlugin(
      selector: PromiseOrValue<BytesLike>,
      functionSignature: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    updatePlugin(
      plugin: IRouter.PluginStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;
  };
}
